package com.perforce.hws.swagger.asciidoc;

import com.perforce.hws.swagger.asciidoc.models.Definition;
import com.perforce.hws.swagger.asciidoc.models.Route;
import io.swagger.models.Swagger;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by tristan on 4/18/16.
 */
public interface HWSSwaggerMethods {

    default List<Route> convertToRoutes(Swagger swagger) {
        List<Route> routes = new ArrayList<>();

        swagger.getPaths().forEach((subPath, path) -> {
            path.getOperationMap().forEach((method, operation) -> {
                routes.add(new Route(method, operation, path, subPath));
            });
        });

        // TODO we probably want to figure out a nice sorted order, probably based around
        // path, then method

        return routes;
    }

    default List<Definition> convertToDefinitions(Swagger swagger) {
        List<Definition> definitions = new ArrayList<>();

        swagger.getDefinitions().forEach((id, model) -> definitions.add(new Definition(id, model)));

        return definitions;
    }
}
